%%% File    : client_sup.erl
%%% Author  : Clara Benac Earle <clara@bacardi>
%%% Purpose : supervisor for clients.
%%% Created : 12 Apr 2001 by Clara Benac Earle <clara@bacardi>
%%% Modified: 08 Jun 2001 by Thomas Arts <thomas@cslab.ericsson.se>

-module(client_sup).
-author('clara@bacardi').

-behaviour(supervisor).

-export([start_link/2, init/1]).

start_link(Locker,ResTypes) ->   
    supervisor:start_link(?MODULE, {Locker,ResTypes}).

init({Locker,ResTypes}) ->
    {ok,{{one_for_one,2,60},create_clients(Locker,ResTypes,1)}}.

create_clients(Locker,[],N) ->
  [];
create_clients(Locker,[{Resources,Type}|ResTypes],N) ->
    [{N,{client,start_link,[Locker,Resources,Type]},
                            permanent, 2000, worker, dynamic}|
     create_clients(Locker,ResTypes,N+1)].

